from game import *
from crash import *
import math
import random

image_ball = [
    image('ball0.png'), image('ball1.png'), image('ball2.png'),
    image('ball3.png'), image('ball4.png'), image('ball5.png'),
    image('ball6.png')]

SW, SH = 1, 9/16
radius = 0.08

def ball(b):
    if b.state == 0:
        b.vy -= 0.001
        b.x += b.vx
        b.y += b.vy
        r = radius*2.5
        for m in group(ball):
            d = math.dist((b.x, b.y), (m.x, m.y))
            if 0 < d < r:
                dx, dy = b.x-m.x, b.y-m.y
                vx, vy = m.x+dx/d*r-b.x, m.y+dy/d*r-b.y
                b.x += vx*0.25
                b.y += vy*0.25
                b.r -= vx*0.1
                b.vy *= 0.9
        if b.y < -SH+b.sy:
            b.y = -SH+b.sy
            b.vy = 0
        if abs(b.x) > SW+b.sx:
            b.life = 0

def stage(s):
    if random.random() < 0.1:
        kind = random.randrange(len(image_ball))
        add(ball, image_ball[kind], radius, 
            random.uniform(-0.9, 0.9), SH+radius, kind=kind)

def start():
    add(stage)

run(start, 1280, 720)
