from game import *
from crash import *
import math
import random
import re

image_player = image('bear.png')
image_enemy = image('panda.png')
image_weapon = image('bear_weapon.png')
image_bullet = image('panda_bullet.png')

SW, SH = 1, 9/16

def player(p):
    for b in group(bullet):
        d = math.dist((b.x, b.y), (p.x, p.y))
        if d < 0.2:
            if key(LEFT) and not key(RIGHT) and p.state == 0:
                new_crash(b.x, b.y, 0.01, 10, 0.95)
                b.life = 0
            else:
                new_crash(p.x, p.y, 0.01, 20, 0.98)
                p.life = 0
    if p.state == 0:
        if key(LEFT) and not key(RIGHT):
            if not key_old(LEFT):
                p.time = 0
            p.time = min(60, p.time+1)
            p.r += (0.05-p.r)*0.2
        elif not key(LEFT) and key(RIGHT) and p.time > 30:
            add(weapon, image_weapon, 0.1, p.x+0.1, p.y-0.15, 0.01, 0)
            p.time = 0
            p.state = 1
        else:
            p.time = max(0, p.time-1)
            p.r += (0-p.r)*0.2
    elif p.state == 1:
        p.time += 1
        p.r += (-0.1-p.r)*0.2
        if p.time > 60:
            p.time = 0
            p.state = 0

def weapon(w):
    w.x += w.vx
    w.y += w.vy
    w.time += 1
    w.sy = w.sx+math.sin(w.time*0.3)*0.01
    if abs(w.x)>SW+w.sx:
        w.life = 0
    for e in group(enemy):
        d = math.dist((e.x, e.y), (w.x, w.y))
        if d < 0.2:
            new_crash((e.x+w.x)/2, (e.y+w.y)/2, 0.01, 20, 0.98)
            w.life = 0
    for b in group(bullet):
        d = math.dist((b.x, b.y), (w.x, w.y))
        if d < 0.1:
            new_crash((b.x+w.x)/2, (b.y+w.y)/2, 0.01, 10, 0.95)
            b.life = w.life = 0

def enemy(e):
    if random.random()<0.02:
        if random.random()<0.5:
            add(bullet, image_bullet, 0.1, 
                e.x-0.1, e.y+0.03, -0.01, 0)
        else:
            add(bullet, image_bullet, 0.1, 
                e.x-0.1, e.y-0.15, -0.01, 0)

def bullet(b):
    b.x += b.vx
    b.r += 0.01
    if abs(b.x) > SW+b.sx:
        b.life = 0

def start():
    add(player, image_player, 0.2, -0.7, 0, sy=0.3)
    add(enemy, image_enemy, 0.2, 0.7, 0, sy=0.3)

run(start, 1280, 720)
