from game import *
from crash import *
import math
import random

image_player = image('chicken.png')
image_enemy = image('car.png')

SW, SH = 1, 9/16

def player(p):
    v = 0.01
    if key(LEFT):
        p.x -= v
    if key(RIGHT):
        p.x += v
    if key(UP):
        p.y += v
    if key(DOWN):
        p.y -= v
    p.x = max(-SW+p.sx, min(SW-p.sx, p.x))
    p.y = max(-SH+p.sy, min(SH-p.sy, p.y))
    for e in group(enemy):
        if math.dist((p.x, p.y), (e.x, e.y)) < (p.sx+e.sx)*0.5:
            new_crash(p.x, p.y, 0.01, 20, 0.98)
            p.life = 0

def enemy(e):
    e.x += e.vx
    e.r = math.sin(e.time*0.2)*0.01
    e.time += 1
    if abs(e.x) > SW+e.sx:
        e.life = 0

def stage(s):
    if random.random() < 0.05:
        size = 0.1
        side = random.choice([-1, 1])
        y = random.uniform(-SH+size, SH-size)
        add(enemy, image_enemy, size, (SW+size)*side, y, -0.01*side)

def start():
    add(stage)
    add(player, image_player, 0.08)

run(start, 1280, 720)
