from game import *
from crash import *
import math
import random

image_player = image('chicken.png')
image_enemy = image('car.png')
image_target = image('chick.png')

SW, SH = 1, 9/16

def player(p):
    if key(LSHIFT) or key(RSHIFT):
        n = 8
        if p.state == 0:
            v = p.sx*2/n
            p.vx = p.vy = 0
            if key(LEFT):
                p.vx = -v
            elif key(RIGHT):
                p.vx = v
            elif key(UP):
                p.vy = v
            elif key(DOWN):
                p.vy = -v
            if p.vx or p.vy:
                p.time = 0
                p.state = 1
        if p.state == 1:
            p.x += p.vx
            p.y += p.vy
            p.time += 1
            if p.time == n:
                p.state = 2
        if p.state == 2:
            if not key(LEFT) and not key(RIGHT) \
                and not key(UP) and not key(DOWN):
                p.state = 0
    else:
        v = 0.01
        if key(LEFT):
            p.x -= v
        if key(RIGHT):
            p.x += v
        if key(UP):
            p.y += v
        if key(DOWN):
            p.y -= v
    p.x = max(-SW+p.sx, min(SW-p.sx, p.x))
    p.y = max(-SH+p.sy, min(SH-p.sy, p.y))
    for e in group(enemy):
        if math.dist((p.x, p.y), (e.x, e.y)) < (p.sx+e.sx)*0.5:
            new_crash(p.x, p.y, 0.01, 20, 0.98)
            p.life = 0

def enemy(e):
    e.x += e.vx
    e.r = math.sin(e.time*0.2)*0.01
    e.time += 1
    if abs(e.x) > SW+e.sx:
        e.life = 0

def stage(s):
    if random.random() < 0.05+0.005*score():
        size = 0.1
        side = random.choice([-1, 1])
        y = random.uniform(-SH+size, SH-size)
        add(enemy, image_enemy, size, (SW+size)*side, y, -0.01*side)

def target(t):
    for p in group(player):
        if math.dist((t.x, t.y), (p.x, p.y)) < (p.sx+t.sx)*0.5:
            new_crash(t.x, t.y, 0.01, 10, 0.95)
            score(1)
            t.x = random.uniform(-SW+t.sx, SW-t.sx)
            t.y = -t.y

def start():
    score()
    add(stage)
    size = 0.08
    add(player, image_player, size, 0, -SH+size)
    add(target, image_target, size, 0, SH-size)

run(start, 1280, 720)
