from game import *
from crash import *
import math
import random

image_player = image('bird.png')
image_enemy = image('pig.png')
image_sling = image('sling.png')
image_route = image('route.png')
image_wall = image('floor.png')

SW, SH = 1, 9/16
cx, cy = -0.5, 0
gravity = 0.001

def fly(m):
    m.vy -= gravity
    m.x += m.vx
    m.y += m.vy
    for w in group(wall):
        dx, dy = m.x-w.x, m.y-w.y
        ax, ay = abs(dx), abs(dy)
        sx, sy = m.sx+w.sx, m.sy+w.sy
        if ax < sx and ay < sy:
            if ax > ay:
                m.vx = math.copysign(m.vx, dx)
            else:
                m.vy = math.copysign(m.vy, dy)

def player(p):
    mx, my, mb = mouse()
    mox, moy, mob = mouse_old()
    d = math.dist((mx, my), (cx, cy))
    if p.state == 0:
        p.x, p.y = cx, cy
        p.vx, p.vy = 0.01, 0
        p.sx = p.sy = 0.05
        if mb and d < p.sx*1.5:
            p.state = 1
    elif p.state == 1:
        v = min(0.05, d*0.2)
        if d:
            p.vx, p.vy = (cx-mx)/d*v, (cy-my)/d*v
        if mb:
            p.x, p.y = mx, my
        elif mob:
            p.state = 2
    elif p.state == 2:
        fly(p)
        if p.y+p.sy < -SH:
            p.state = 0
    p.r = math.atan2(p.vy, p.vx)/math.pi/2

def sling(s):
    for p in group(player):
        if p.state == 1:
            s.x, s.y = (p.x+cx)/2, (p.y+cy)/2
            s.sx = math.dist((p.x, p.y), (cx, cy))/2
            s.sy = 0.01
            s.r = math.atan2(p.y-cy, p.x-cx)/math.pi/2
        else:
            s.sx = s.sy = 0

def wall(w):
    pass

def start():
    add(sling, image_sling, 0, cx, cy)
    add(player, image_player, 0.05, cx, cy)
    for i in range(8):
        x = cx+0.3+0.15*i
        y = random.uniform(-SH+0.2, SH-0.2)
        add(wall, image_wall, 0.05, x, y)

run(start, 1280, 720)
